
//Test Command String = ~+0000,+0000,+0000,+0000
//Test Command String = ~+0255,+0255,+0255,+3200
//                        M1    M2    M3    LACT

char targetCommandString[] = {' ',' ',' ',' ',' '};

#define KEEP_ALIVE_TIMEOUT_1 1000 
#define KEEP_ALIVE_TIMEOUT_2 38 ////roughly every 2 seconds
int keepAlive_1 = KEEP_ALIVE_TIMEOUT_1;
int keepAlive_2 = KEEP_ALIVE_TIMEOUT_2;


int target_Motor1_Command = 0;
int target_Motor2_Command = 0;
int target_FlipperMotor_Command = 0;
int target_LACT_Command = 0;



//----- IR BLOCK -----
#include <SharpIR.h>

#define IR_FRONT_LEFT         A5
#define IR_FRONT_RIGHT        A4
#define IR_LEFT               A3
#define IR_RIGHT              A2
#define IR_BACK_LEFT          A1
#define IR_BACK_RIGHT         A0

#define LONG_RANGE_IR_SENSOR  20150
#define MED_RANGE_IR_SENSOR   1080

SharpIR IR_FL(IR_FRONT_LEFT, LONG_RANGE_IR_SENSOR);
SharpIR IR_FR(IR_FRONT_RIGHT, LONG_RANGE_IR_SENSOR);
SharpIR IR_L(IR_LEFT, MED_RANGE_IR_SENSOR);
SharpIR IR_R(IR_RIGHT, MED_RANGE_IR_SENSOR);
SharpIR IR_BL(IR_BACK_LEFT, LONG_RANGE_IR_SENSOR);
SharpIR IR_BR(IR_BACK_RIGHT, LONG_RANGE_IR_SENSOR);
//--------------------


void setup() {
  // put your setup code here, to run once:
  Serial.begin( 250000 );

  Serial.println("iBot v1.0 by OrbitusRobotics");
  Serial.println("BEGIN STARTUP SEQUENCE");

  //---- IR BLOCK SETUP ----
  pinMode( IR_FRONT_LEFT, INPUT);
  pinMode( IR_FRONT_RIGHT, INPUT);
  pinMode( IR_LEFT, INPUT);
  pinMode( IR_RIGHT, INPUT);
  pinMode( IR_BACK_LEFT, INPUT);
  pinMode( IR_BACK_RIGHT, INPUT);
  //------------------------

  Serial.println("STARTUP SEQUENCE COMPLETE");
  Serial.println("iBot v1.0 ONLINE");
}

void loop() {
  // put your main code here, to run repeatedly:
    keepAlive_SAFTEYSTOP();
    
    if(Serial.available() > 0 && irReadOut()) {
 
      Serial.print("Parsing Serial\n");
  
      byte b =  Serial.read();
      
      if (b == 126)
      {
        char charIn = 0;
  
        targetCommandString[0] = Serial.read();
        targetCommandString[1] = Serial.read();
        targetCommandString[2] = Serial.read();
        targetCommandString[3] = Serial.read();
        targetCommandString[4] = Serial.read();

        Serial.read(); //READ THE COMMA SEPARATING THINGS!!!
        //Serial.print("TargetCommandString M1:");
        //Serial.print( targetCommandString );
        target_Motor1_Command = atoi(targetCommandString);
  
        targetCommandString[0] = Serial.read();
        targetCommandString[1] = Serial.read();
        targetCommandString[2] = Serial.read();
        targetCommandString[3] = Serial.read();
        targetCommandString[4] = Serial.read();

        Serial.read(); //READ THE COMMA SEPARATING THINGS!!!
        //Serial.print("TargetCommandString M2:");
        //Serial.print( targetCommandString );
        target_Motor2_Command = atoi(targetCommandString);
        
        targetCommandString[0] = Serial.read();
        targetCommandString[1] = Serial.read();
        targetCommandString[2] = Serial.read();
        targetCommandString[3] = Serial.read();
        targetCommandString[4] = Serial.read();

        Serial.read(); //READ THE COMMA SEPARATING THINGS!!!
        //Serial.print("TargetCommandString FLipper:");
        //Serial.print( targetCommandString );
        target_FlipperMotor_Command = atoi(targetCommandString);
  
        targetCommandString[0] = Serial.read();
        targetCommandString[1] = Serial.read();
        targetCommandString[2] = Serial.read();
        targetCommandString[3] = Serial.read();
        targetCommandString[4] = Serial.read();
  
        Serial.read(); //READ THE COMMA SEPARATING THINGS!!!
        //Serial.print("TargetCommandString LACT:");
        //Serial.print( targetCommandString );
        target_LACT_Command = atoi(targetCommandString);
  
  
        Serial.println("--------- NEW TARGET Motor Values -----------");
        Serial.print("target_Motor1_Command: ");
        Serial.println(target_Motor1_Command);
        Serial.print("target_Motor2_Command: ");
        Serial.println(target_Motor2_Command);      
        Serial.print("target_FlipperMotor_Command: ");
        Serial.println(target_FlipperMotor_Command);      
        Serial.print("target_LACT_Command: ");
        Serial.println(target_LACT_Command);      
        Serial.println("---------------------------------------");
        
        //irReadOut();
        
        Serial.println("---------------------------------------");
        
      }
   }
}


int irReadOut()
{
  /* Check for obstacles */
  Serial.print( "( " );
  Serial.print( IR_FL.distance() );
  Serial.print( ", " );
  Serial.print( IR_FR.distance() );
  Serial.print( ", " );
  Serial.print( IR_L.distance() );
  Serial.print( ", " );
  Serial.print( IR_R.distance() );
  Serial.print( ", " );
  Serial.print( IR_BL.distance() );
  Serial.print( ", " );
  Serial.print( IR_BR.distance() );
  Serial.print( ")\n" );


  /* Avoid reading before the new distance is sampled */
  delay( 100 );
  return 1;
}


void keepAlive_SAFTEYSTOP()
{
  keepAlive_1--;
    if (keepAlive_1 %1000 == 0)
    {
      //Serial.println(keepAlive);
    }
    if (keepAlive_1 <= 0)
    {
      //MAKE SURE TO SET MOTORS BACK TO ZERO AFTER THE TIMEOUT IN CASE OF FAILURE AT FULL SPEED
      keepAlive_1 = 10000;
      keepAlive_2--;
      Serial.println(keepAlive_2);
    }
    if (keepAlive_2 <= 0)
    {
      Serial.print("KEEPALIVE HAS EXPIRED!!! SHUTTING DOWN CONNECTION NOW\n");
      keepAlive_2 = KEEP_ALIVE_TIMEOUT_2;
    }
}

